local QW_MOVEWINDOW = "NONE"
local watch = {}

function QuickWarnings_ResetLists()
	ChatFrame1:AddMessage("Quick Warnings: Reseting ALL lists...", 0.4, 0.3, 1);
	
	QuickWarnings_CheckingBuffs = {
									-- DEATH KNIGHT -- Watched Buffs
									"Dark Succor", "Killing Machine", "Crimson Scourge",
									
									-- DEMON HUNTER -- Watched Buffs
									"Soul Fragments",
									
									-- DRUID -- Watched Buffs
									"Clearcasting", "Soul of the Forest", "Tooth and Claw",
									"Mangle!", 
									
									-- HUNTER -- Watched Buffs
									"Marking Targets", "Thrill of the Hunt", "Trick Shot","Lock and Load", 
									
									-- MONK -- Watched Buffs
									"Moderate Stagger", "Heavy Stagger","Blackout Combo",
									
									-- MAGE -- Watched Buffs
									"Pyroblast!", "Heating Up", "Ice Floes",
									"Hot Streak!",
									
									-- PALADIN -- Watched Buffs
									"Daybreak", "Grand Crusader",
									
									-- PRIEST -- Watched Buffs
									"Serendipity", "Mending", "Surge of Light", "Divine Insight", 
									"Borrowed Time", 
									
									-- SHAMAN -- Watched Buffs
									"Tidal Waves", "Unleash Life", "Undulation","Lava Surge",
									
									-- WARLOCK --
									 "Backdraft",
									
									-- WARRIOR -- Watched Buffs
									"Sword and Board", "Ultimatum", "Victorious", "Sudden Death",
									"Meat Cleaver", "Bloodsurge", "Victory Rush", 
									"Vengeance: Focused Rage", "Vengeance: Ignore Pain",
									"Dragon Scales",
									
									-- Others
									"Preparation", "Dungeon Preparation",
								}
	QuickWarnings_CheckingBuffs_Ignore = {
										-- DEATH KNIGHT -- ignored buffs
										"Blood Presence", "Frost Presence", "Unholy Presence", "Death and Decay",
										"Power of the Grave", "Unholy Aura", "Horn of Winter", "Defile",
										
										-- DRUID -- ignored buffs
										"Bear Form", "Dire Bear Form", "Aquatic Form", "Cat Form", "Travel Form",
										"Moonkin Form", "Tree of Life Form", "Flight Form", "Swift Flight Form",
										"Leader of the Pack", "Track Humanoids", "Rejuvenation", "Regrowth",
										"Living Seed", "Lifebloom", "Prowl", "Barkskin", "Dash", "Nature's Grasp",
										"Stag Form", "Genesis", "Mark of the Wild", "Ironbark", "Primal Tenacity",
										"Rejuvenation (Germination)", 
										
										-- HUNTER -- ignored buffs
										"Sniper Training", "Trap Launcher", "Trueshot Aura","Bombardment", 
										
										-- MAGE -- ignored buffs
										"Blink", "Arcane Brilliance", "Ice Block", "Hypothermia",
										"Amplify Magic", "Slow Fall",
										
										-- MONK -- ignored buffs
										"Light Stagger",
										"Stance of the Fierce Tiger", "Stance of the Sturdy Ox",
										"Legacy of the White Tiger", "Transcendence",
										
										-- PALADIN -- ignored buffs
										"Blessing of Might", "Seal of Righteousness",
										"Seal of Insight", "Seal of Command",
										"Righteous Fury",
										
										-- PRIEST -- ignored buffs
										"Power Word: Shield", "Levitate", "Mind Vision", "Hymn of Hope",
										"Power Word: Fortitude", "Weakened Soul", "Divine Hymn", "Fade",
										"Fear Ward", "Renew", "Inner Fire", "Inner Will", "Echo of Light",
										"Chakra: Chastise", "Chakra: Sanctuary", "Chakra: Serenity", 
										"Holy Word: Serenity", "Word of Mending", "Lightwell Renew",
										
										-- ROGUE -- ignored buffs
										"Swiftblade's Cunning", 
										
										-- SHAMAN -- ignored buffs
										"Burning Wrath", "Grace of Air", "Ghost Wolf", "Earthliving",
										"Far Sight", "Bloodlust",
										"Water Shield", "Earth Shield", "Lightning Shield",
										"Windflurry",
										
										-- WARLOCK -- ignored buffs
										"Dark Intent", "Blood Pact",
										
										-- WARRIOR -- ignored buffs
										"Battle Stance", "Defensive Stance", "Berserker Stance",
										"Commanding Shout", "Inspiring Presence", "Gladiator Stance",
										"Bladestorm", "Battle Shout", "Charge", "Resolve",
										
										-- Professions -- ignored buffs
										"Find Minerals", "Find Herbs", "Find Fish", "Find Treasure",
										"Elixir of Mirrors", "Elixir of Mighty Defense",
										"Elixir of Deep Earth", "Elixir of Might Speed", "Elixir of Peace",
										"Elixir of Perfection", "Elixir of Weaponry",
										"Exarch Elixir", "Frostwolf Elixir", "Steamwheedle Elixir",
										"Unstable Elixir", "Mantid Elixir",
										"Flask of the Earth", "Flask of Battle",
										"Flask of Conquest", "Flask of Fortification",
										"Flask Steelskin", "Flask Stoneblood",
										"Draenic Intellect Flask", "Draenic Strength Flask",
										"Draenic Agility Flask", "Draenic Stamina Flask",
										"Greater Draenic Intellect Flask", "Greater Draenic Strength Flask",
										"Greater Draenic Agility Flask", "Greater Draenic Stamina Flask",
										"Flask of the Earth", "Flask of the Warm Sun",
										
										-- Others -- ignored buffs
										"Fishing", "Well Fed", "\"Well Fed\"", 
										"Sated", "Temporal Displacement", "Insanity", "Exhaustion", 
										"Shamanstone: Spirit of the Wolf", "Shamanstone: Blessing of the Wolf", 
										"Recently Mass Resurrected", "Demonic Gateway", "Dressed to Kill",
										"Miner's Coffee", "Preserved Mining Pick", 
										"Stout Augmentation", "Hyper Augmentation",
										"Focus Augmentation", "Hyper Augmentation",
										"Whispers of Insanity", 
										"Sign of the Skirmisher", "Sign of Apexis",
										"Sign of Battle", "Sign of the Emissary",
										"Sign of the Warrior", "Training Gear",
										"Nazgrel's Fervor", "Blessing of Auchindoun",
										"Mana Divining Stone",
										--"", 
									}

	QuickWarnings_CheckingBuffs_AlternateIcon = {
													-- Mage
													--{"Heating Up",108853},
													-- Warrior
													{"Vengeance: Ignore Pain",203177},
												}
										
	QuickWarnings_CheckingBuffs_Researching = {}

end

function QuickWarnings_ClearLists()
	ChatFrame1:AddMessage("Quick Warnings: Clearing ALL lists...", 1, 0.4, 0.3);
	
	QuickWarnings_CheckingBuffs = {}
	QuickWarnings_CheckingBuffs_Ignore = {}
	QuickWarnings_CheckingBuffs_Researching = {}
	QuickWarnings_CheckingBuffs_AlternateIcon = {}
end

local timer
local tcount
local ttcount
local password = math.random(9999)

function QuickWarnings_SlashCommand(cmd)
	if (cmd == "mv") then
		if (#watch > 19) then
			ChatFrame1:AddMessage("Quick Warnings: You can't get enough, can you? :D", 0, 1, 0);
		elseif (#watch > 10) then
			ChatFrame1:AddMessage("Quick Warnings: Are you having fun? :)", 0, 1, 0);
		end

		tcount = 4
		ttcount = GetTime()
		timer = ttcount + 7
		QuickWarningsFrame:SetWidth(64)
		QuickWarningsFrame:SetHeight(64)
		QuickWarningsFrame:SetAlpha(1)
		QuickWarningsFrame:EnableMouse(true)

		--AddSpellToWatch(QW_MOVEWINDOW, "Interface\\Icons\\INV_Misc_QuestionMark")
	elseif (cmd == "reset") then
		password = math.random(9999)
		ChatFrame1:AddMessage("Your Quick Warnings reset password is "..password, 0.6, 0.4, 1);
		ChatFrame1:AddMessage("use:", 0.6, 0.4, 1);
		ChatFrame1:AddMessage("/qw reset "..password, 0.6, 0.4, 1);
	elseif (cmd == "clear") then
		password = math.random(9998)
		ChatFrame1:AddMessage("Your Quick Warnings clear password is "..(password + 1), 1, 0.4, 0.3);
		ChatFrame1:AddMessage("use:", 1, 0.4, 0.3);
		ChatFrame1:AddMessage("/qw clear "..(password + 1), 1, 0.4, 0.3);
	elseif (cmd == "list") then
		for i = 1, #QuickWarnings_CheckingBuffs do
			ChatFrame1:AddMessage("["..i.."] "..QuickWarnings_CheckingBuffs[i], 0, 1, 0);
		end
	elseif (cmd == "il") then
		for i = 1, #QuickWarnings_CheckingBuffs_Ignore do
			ChatFrame1:AddMessage("["..i.."] "..QuickWarnings_CheckingBuffs_Ignore[i], 1, 0, 0);
		end
	elseif (cmd == "rl") then
		for i = 1, #QuickWarnings_CheckingBuffs_Researching do
			ChatFrame1:AddMessage("["..i.."] "..QuickWarnings_CheckingBuffs_Researching[i][1], 1, 1, 0);
		end
	elseif (cmd == "al") then
		for i = 1, #QuickWarnings_CheckingBuffs_AlternateIcon do
			ChatFrame1:AddMessage("["..i.."] "..QuickWarnings_CheckingBuffs_AlternateIcon[i][1].."="..QuickWarnings_CheckingBuffs_AlternateIcon[i][2], 1, 1, 0);
		end
	elseif (string.sub(cmd, 1, 6) == "reset ") then
		local pw = string.sub(cmd, 6 - string.len(cmd))
		if (pw == ""..password) then
			QuickWarnings_ResetLists()
		else
			ChatFrame1:AddMessage("Quick Warnings: wrong reset password", 0.6, 0.4, 1);
		end
	elseif (string.sub(cmd, 1, 6) == "clear ") then
		local pw = string.sub(cmd, 6 - string.len(cmd))
		if (pw == ""..(password + 1)) then
			QuickWarnings_ClearLists()
		else
			ChatFrame1:AddMessage("Quick Warnings: wrong clear password", 1, 0.4, 0.3);
		end
	elseif (string.sub(cmd, 1, 2) == "c ") then
		local name = string.sub(cmd, 2 - string.len(cmd))
		QuickWarnings_CheckingBuffs[#QuickWarnings_CheckingBuffs + 1] = name
		for i = 1, #QuickWarnings_CheckingBuffs_Ignore do
			if (QuickWarnings_CheckingBuffs_Ignore[i] == name) then
				QuickWarnings_CheckingBuffs_Ignore[i] = QuickWarnings_CheckingBuffs_Ignore[#QuickWarnings_CheckingBuffs_Ignore]
				QuickWarnings_CheckingBuffs_Ignore[#QuickWarnings_CheckingBuffs_Ignore] = nil
			end
		end
		ChatFrame1:AddMessage(name.." is now always considered by Quick Warnings.", 0, 1, 0);
	elseif (string.sub(cmd, 1, 2) == "i ") then
		local name = string.sub(cmd, 2 - string.len(cmd))
		if (name == QW_MOVEWINDOW) then
			ChatFrame1:AddMessage("You can't ignore "..QW_MOVEWINDOW, 1, 0.8, 0.7);
		else
			QuickWarnings_CheckingBuffs_Ignore[#QuickWarnings_CheckingBuffs_Ignore + 1] = name
			for i = 1, #QuickWarnings_CheckingBuffs do
				if (QuickWarnings_CheckingBuffs[i] == name) then
					QuickWarnings_CheckingBuffs[i] = QuickWarnings_CheckingBuffs[#QuickWarnings_CheckingBuffs]
					QuickWarnings_CheckingBuffs[#QuickWarnings_CheckingBuffs] = nil
				end
			end
			ChatFrame1:AddMessage(name.." is now being ignored by Quick Warnings.", 1, 0, 0);
		end
	elseif (string.sub(cmd, 1, 2) == "a ") then
		local name = string.sub(cmd, 2 - string.len(cmd))

		-- parse number (last word. there must be a better way to do this)
		local aa, bb
		aa = 1
		while true do
			aa = string.find(name, ' ', aa + 1)
			if (aa == nil) then
				break
			end
			bb = aa
		end

		local number = string.sub(name, bb)
		number = number + 0

		local _
		_,_,aa = GetSpellInfo(number)
		name = string.sub(name, 1, bb - 1)
		
		if (number == 0) then
			aa = 0
		end

		if (aa) then
			bb = nil
			local cc = nil
			for i = 1, #QuickWarnings_CheckingBuffs do
				if (QuickWarnings_CheckingBuffs[i] == name) then
					for i = 1, #QuickWarnings_CheckingBuffs_AlternateIcon do
						if (QuickWarnings_CheckingBuffs_AlternateIcon[i][1] == name) then
							if (aa == 0) then
								QuickWarnings_CheckingBuffs_AlternateIcon[i] = QuickWarnings_CheckingBuffs_AlternateIcon[#QuickWarnings_CheckingBuffs_AlternateIcon]
								QuickWarnings_CheckingBuffs_AlternateIcon[#QuickWarnings_CheckingBuffs_AlternateIcon] = nil
								bb = 2
							else
								QuickWarnings_CheckingBuffs_AlternateIcon[i][2] = number
								bb = 1
							end
							break;
						end
					end
					if (not bb and not (aa == 0)) then
						QuickWarnings_CheckingBuffs_AlternateIcon[#QuickWarnings_CheckingBuffs_AlternateIcon + 1] = {name, number}
						bb = 1
					end
				end
			end
			if (bb) then
				if (bb == 2) then
					ChatFrame1:AddMessage(name.." is now using its own icon.", 1, 1, 0);
				else
					ChatFrame1:AddMessage(name.." is now using icon from spell ID "..number..", which is "..aa, 1, 1, 0);
				end
			end
		else
			ChatFrame1:AddMessage("Spell ID "..number.." does not have a valid icon.", 1, 1, 0);
		end
	else
		ChatFrame1:AddMessage("/qw: this help", 1, 0.8, 0.7);
		ChatFrame1:AddMessage("/qw list: list all watched buffs (there might be a lot!)", 1, 0.8, 0.7);
		ChatFrame1:AddMessage("/qw il: list all ignored buffs (there are be a lot!)", 1, 0.8, 0.7);
		ChatFrame1:AddMessage("/qw rl: list all buffs still being researched (there might be a lot!)", 1, 0.8, 0.7);
		ChatFrame1:AddMessage("/qw al: list buffs that are using alternate icon", 1, 0.8, 0.7);
		ChatFrame1:AddMessage("/qw i Xxx: start ignoring buff with name Xxx", 1, 0.8, 0.7);
		ChatFrame1:AddMessage("/qw c Xxx: include buff with name Xxx to the watch list", 1, 0.8, 0.7);
		ChatFrame1:AddMessage("/qw a Xx Xxx nnn: Make buff with name Xx Xxx appear with the icon of spell ID nnn (a number! Use 0 to make it back to normal)", 1, 0.8, 0.7);
		ChatFrame1:AddMessage("/qw mv: Drag the box to move Quick Warnings position", 1, 0.8, 0.7);
		ChatFrame1:AddMessage("/qw clear: clears all your lists (confirmation required)", 1, 0.8, 0.7);
		ChatFrame1:AddMessage("/qw reset: resets your lists to default (confirmation required)", 1, 0.8, 0.7);
	end
end

function QuickWarnings_OnMouseDown(self)
		--ChatFrame1:AddMessage("/qw down", 1, 0.8, 0.7);
	self:StartMoving()
	timer = GetTime() + 60 * 60 * 24
end

function QuickWarnings_OnMouseUp(self)
		--ChatFrame1:AddMessage("/qw up", 1, 0.8, 0.7);
	self:StopMovingOrSizing()
	timer = GetTime() + 4
end

function QuickWarnings_OnLoad(self)
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	self:RegisterEvent("PLAYER_DEAD");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");

	SlashCmdList["QuickWarnings"] = QuickWarnings_SlashCommand;
	SLASH_QuickWarnings1 = "/qw"
	
	if (QuickWarnings_CheckingBuffs == nil) then
		QuickWarnings_ResetLists()
	end
	
	self:SetBackdropColor(0.3, 0.2, 0.6)
	self:SetAlpha(0)
end 

local time = 0
function QuickWarnings_OnUpdate(self)
	if (timer) then
		--local barBG = getglobal(self:GetName().."Border")
		if (timer < GetTime()) then
			timer = nil
			tcount = 0
			ttcount = nil
			--QuickWarningsFrame:SetWidth(0.01)
			--QuickWarningsFrame:SetHeight(0.01)
			QuickWarningsFrame:SetAlpha(0)
			QuickWarningsFrame:EnableMouse(false)
			RemoveSpellFromWatch(QW_MOVEWINDOW)
		elseif (tcount > 0) then
			if (ttcount + 1 < GetTime()) then
				ttcount = GetTime() - 0.8
				tcount = tcount - 1
				AddSpellToWatch(QW_MOVEWINDOW, "Interface\\Icons\\INV_Misc_QuestionMark")
				watch[#watch][4] = GetTime() + 60 * 60
			end
		end
	end

	if (time < GetTime()) then
		time = GetTime() + 1
		
		local i = 1
		local duration = 0
		while true do
			local buffName, _, _, count, _, duration, buffFinishTime, isMine = UnitBuff("player", i);
			if (buffName == nil) then
				break
			end
			if (isMine) then
				for i = 1, #watch do
					if (buffName == watch[i][2]) then
						if (buffFinishTime - GetTime() > 5000) then
							watch[i][4] = 0
							RemoveSpellFromWatch(watch[i][2])
						else
							watch[i][4] = buffFinishTime
							watch[i][10]:SetCooldown(buffFinishTime - duration, duration)
							if (count > 1) then
								watch[i][11]:SetText(count)
								watch[i][11]:Show()
							else
								watch[i][11]:Hide()
							end
						end
					end
				end
			end
			i = i + 1
		end

		ReOrder()
	end
	
	for i = 1, #watch do
		if (watch[i][1]:GetAlpha() == 1) then
			watch[i][1]:SetWidth(56 + 8 * math.sin(4 * (watch[i][3] + GetTime())))
			watch[i][1]:SetHeight(56 + 8 * math.sin(4 * (watch[i][3] + GetTime())))
			
			watch[i][6]:SetWidth(56 + 8 * math.sin(4 * (watch[i][3] + GetTime() - 0.3)))
			watch[i][6]:SetHeight(56 + 8 * math.sin(4 * (watch[i][3] + GetTime() - 0.3)))
			watch[i][7]:SetWidth(56 + 8 * math.sin(4 * (watch[i][3] + GetTime() - 0.7)))
			watch[i][7]:SetHeight(56 + 8 * math.sin(4 * (watch[i][3] + GetTime() - 0.7)))
		end
	end

	ReorganizeWatchingBuffs()
end

function RemoveSpellFromWatch(name)
	local still = true
	
	while (still) do
		still = false
		for i = 1, #watch do
			if (watch[i][2] == name) then
				watch[i][10]:ClearAllPoints()
				watch[i][10]:Hide()
				watch[i][1]:ClearAllPoints()
				watch[i][1]:Hide()
				if (watch[i][6]) then
					watch[i][6]:ClearAllPoints()
					watch[i][6]:Hide()
					watch[i][7]:ClearAllPoints()
					watch[i][7]:Hide()
				end
				if (watch[i][4] - 0.4 < GetTime()) then
					PointDown(name)
				else
					PointUp(name)
				end
				watch[i] = watch[#watch]
				watch[#watch] = nil
				--for j = i, #watch do
				--	watch[j] = watch[j + 1]
				--end
				still = true
				break
			end
		end
	end

--	ReorganizeWatchingBuffs()
end

function ReOrder ()
	for i = 1, #watch - 1 do
		for j = i + 1, #watch do
			if (watch[i][4] > watch[j][4]) then
				watch[i], watch[j] = watch[j], watch[i]

				local _, _, _, x, y = watch[i][1]:GetPoint()
				watch[i][1]:ClearAllPoints()
				watch[i][1]:SetPoint("CENTER", "QuickWarningsFrame", "CENTER", x, math.min(y, -12))
				watch[i][9] = math.min(y, -8)

				_, _, _, x, y = watch[j][1]:GetPoint()
				watch[j][1]:ClearAllPoints()
				watch[j][1]:SetPoint("CENTER", "QuickWarningsFrame", "CENTER", x, math.max(12, y))
				watch[j][9] = math.max(8, y)

			end
		end
	end
end

function ReorganizeWatchingBuffs()

	for i = 1, #watch do
		local _, _, _, x, y = watch[i][1]:GetPoint()
		local xx, yy = 66 * (i - 1), 24

		watch[i][8] = watch[i][8] + (xx - x) * 0.04
		watch[i][9] = watch[i][9] + (yy - y) * 0.04
		
		watch[i][8] = watch[i][8] * 0.97
		watch[i][9] = watch[i][9] * 0.97
		
		local dx = math.abs(xx - x)
		local dy = math.abs(yy - y)
		if (dx < 3 or dx > 60) then
			watch[i][8] = watch[i][8] * 0.9
			--	watch[i][8] = 0
			--	x = xx
		end
		if (dy < 3 or dy > 60) then
			watch[i][9] = watch[i][9] * 0.9
			--	watch[i][9] = 0
			--	y = yy
		end

		x = x + watch[i][8] * 0.1
		y = y + watch[i][9] * 0.1
		watch[i][1]:ClearAllPoints()
		watch[i][1]:SetPoint("CENTER", "QuickWarningsFrame", "BOTTOMLEFT", x, y)
		if (watch[i][6]) then
			watch[i][6]:ClearAllPoints()
			watch[i][6]:SetPoint("CENTER", "QuickWarningsFrame", "BOTTOMLEFT", x - watch[i][8], y - watch[i][9])
			watch[i][7]:ClearAllPoints()
			watch[i][7]:SetPoint("CENTER", "QuickWarningsFrame", "BOTTOMLEFT", x - 2 * watch[i][8], y - 2 * watch[i][9])
		end
	end
end

function CreateWarningBuffFrame(name, icon, i)
	local f = CreateFrame("Frame", name, UIParent)
	f:SetFrameStrata("BACKGROUND")
	f:SetWidth(64) 
	f:SetHeight(64)

	local t = f:CreateTexture(nil,"BACKGROUND")
	t:SetTexture(icon)
	t:SetAllPoints(f)
	f.texture = t

	f:SetPoint("CENTER", "QuickWarningsFrame", "CENTER", 66 * i, 31)
	
	return f, t
end

function RefreshSpellToWatch(name, icon)
	for i = 1, #watch do
		if (watch[i][2] == name) then
			watch[i][3] = GetTime()
			break
		end
	end
end

function AddSpellToWatch(name, icon)
	if (name == QW_MOVEWINDOW) then
		if (#watch > 20) then
			return
		end
	end

	if (isInIgnore(name)) then
		return
	end
	
	-- don't show anymore if it's already showing
	if (name ~= QW_MOVEWINDOW) then
		for i = 1, #watch do
			if (watch[i][2] == name) then
				return
			end
		end
	end
	
	
--======================================================================--
-- Tweak to make fire mage's "Heating Up" look like a "Inferno Blast"	--
--	Compare name as they are in the Quick Warnings list					--
--	Must use icon from spell ID. Look for it at www.thottbot.com		--
--	Should be added to list QuickWarnings_CheckingBuffs_AlternateIcon	--
--		at top of this file												--
--======================================================================--
	for i = 1, #QuickWarnings_CheckingBuffs_AlternateIcon do
		if (QuickWarnings_CheckingBuffs_AlternateIcon[i][1] == name) then
			local _
			_,_, icon = GetSpellInfo(QuickWarnings_CheckingBuffs_AlternateIcon[i][2])
		end
	end
--=================================================================--

	local f = CreateWarningBuffFrame(name, icon, #watch)
	f:Show()
	
	local ff, fff = nil, nil
	if (not CheckIfSo(name)) then
		f:SetAlpha(0.5)
		f:SetWidth(56) 
		f:SetHeight(56)
	else
		local tt
		ff, tt = CreateWarningBuffFrame(name, icon, #watch)
		tt:SetBlendMode("ADD")
		ff:SetAlpha(0.5)
		ff:Show()
		fff, tt = CreateWarningBuffFrame(name, icon, #watch)
		tt:SetBlendMode("ADD")
		fff:SetAlpha(0.25)
		fff:Show()

		--f:ClearAllPoints()
		--f:SetPoint("CENTER", "QuickWarningsFrame", "CENTER", 66 * i, 24)
		--ff:ClearAllPoints()
		--ff:SetPoint("CENTER", "QuickWarningsFrame", "CENTER", 66 * i, 24)
		--fff:ClearAllPoints()
		--fff:SetPoint("CENTER", "QuickWarningsFrame", "CENTER", 66 * i, 24)
	end


	local PlayerCooldown = CreateFrame("Cooldown", "PlayerCooldow", PlayerFrame, "CooldownFrameTemplate")
	PlayerCooldown:SetAllPoints(f)

	PlayerCooldown:SetCooldown(GetTime(), 30)
	PlayerCooldown:SetReverse(1)


--	local count = f:CreateFontString("FontInstance", "ARTWORK", "NumberFontNormalSmall")
	local count = f:CreateFontString("FontInstance", "ARTWORK", "NumberFontNormal")
	count:SetPoint("TOP", PlayerCooldown, "BOTTOM", 3, -3)
	--count:SetPoint("BOTTOMRIGHT", PlayerCooldown, "BOTTOMRIGHT", -2, 3)
	count:SetVertexColor(1, 1, 1)
	--count:SetText("23")
	--count:SetFrameLevel(7)
	count:Show()

	watch[#watch + 1] = {f, name, GetTime(), GetTime(), icon, ff, fff, 0, 48, PlayerCooldown, count}
	
	time = GetTime() + 0.1
end

function isInIgnore(name)
	if (name == QW_MOVEWINDOW) then
		return false
	end

	for i = 1, #QuickWarnings_CheckingBuffs_Ignore do
		if (QuickWarnings_CheckingBuffs_Ignore[i] == name) then
			return true
		end
	end
	return false
end

function CheckIfSo(name)
	if (name == QW_MOVEWINDOW) then
		return true
	end

	for i = 1, #QuickWarnings_CheckingBuffs do
		if (QuickWarnings_CheckingBuffs[i] == name) then
			return true
		end
	end
	local found = false
	for i = 1, #QuickWarnings_CheckingBuffs_Researching do
		if (QuickWarnings_CheckingBuffs_Researching[i][1] == name) then
			found = true
		end
	end
	if (not found) then
		QuickWarnings_CheckingBuffs_Researching[#QuickWarnings_CheckingBuffs_Researching + 1] = {name, 0}
	end
	return false
end

function PointDown(name)
	for i = 1, #QuickWarnings_CheckingBuffs_Researching do
		if (QuickWarnings_CheckingBuffs_Researching[i][1] == name) then
			QuickWarnings_CheckingBuffs_Researching[i][2] = QuickWarnings_CheckingBuffs_Researching[i][2] - 2
--DEFAULT_CHAT_FRAME:AddMessage(QuickWarnings_CheckingBuffs_Researching[i][1]..":"..QuickWarnings_CheckingBuffs_Researching[i][2]);
			break
		end
	end
	CheckLists()
end

function PointUp(name)
	for i = 1, #QuickWarnings_CheckingBuffs_Researching do
		if (QuickWarnings_CheckingBuffs_Researching[i][1] == name) then
			QuickWarnings_CheckingBuffs_Researching[i][2] = QuickWarnings_CheckingBuffs_Researching[i][2] + 3
--DEFAULT_CHAT_FRAME:AddMessage(QuickWarnings_CheckingBuffs_Researching[i][1]..":"..QuickWarnings_CheckingBuffs_Researching[i][2]);
			break
		end
	end
	CheckLists()
end

function CheckLists()
	for i = 1, #QuickWarnings_CheckingBuffs_Researching do
		local v = QuickWarnings_CheckingBuffs_Researching[i][2]
		if (v >= 6) then
			QuickWarnings_CheckingBuffs_Researching[i][2] = 50
			QuickWarnings_CheckingBuffs[#QuickWarnings_CheckingBuffs + 1] = QuickWarnings_CheckingBuffs_Researching[i][1]
			ChatFrame1:AddMessage(QuickWarnings_CheckingBuffs_Researching[i][1].." is now always considered by Quick Warnings.", 0, 1, 0);
			QuickWarnings_CheckingBuffs_Researching[i] = QuickWarnings_CheckingBuffs_Researching[#QuickWarnings_CheckingBuffs_Researching]
			QuickWarnings_CheckingBuffs_Researching[#QuickWarnings_CheckingBuffs_Researching] = nil
			break;
		elseif (v <= -6) then
			QuickWarnings_CheckingBuffs_Researching[i][2] = -100
			QuickWarnings_CheckingBuffs_Ignore[#QuickWarnings_CheckingBuffs_Ignore + 1] = QuickWarnings_CheckingBuffs_Researching[i][1]
			ChatFrame1:AddMessage(QuickWarnings_CheckingBuffs_Researching[i][1].." is now being ignored by Quick Warnings.", 1, 0, 0);
			QuickWarnings_CheckingBuffs_Researching[i] = QuickWarnings_CheckingBuffs_Researching[#QuickWarnings_CheckingBuffs_Researching]
			QuickWarnings_CheckingBuffs_Researching[#QuickWarnings_CheckingBuffs_Researching] = nil
			break;
		end
	end
	
--	for i = 1, #QuickWarnings_CheckingBuffs_Researching do
--		for j = 1, #QuickWarnings_CheckingBuffs do
--			if (QuickWarnings_CheckingBuffs_Researching[i][1] == QuickWarnings_CheckingBuffs[j]) then
--				for k = i, #QuickWarnings_CheckingBuffs_Researching do
--					QuickWarnings_CheckingBuffs_Researching[k] = QuickWarnings_CheckingBuffs_Researching[k + 1]
--				end
--				return
--			end
--		end
--		for j = 1, #QuickWarnings_CheckingBuffs_Ignore do
--			if (QuickWarnings_CheckingBuffs_Researching[i][1] == QuickWarnings_CheckingBuffs_Ignore[j]) then
--				for k = i, #QuickWarnings_CheckingBuffs_Researching do
--					QuickWarnings_CheckingBuffs_Researching[k] = QuickWarnings_CheckingBuffs_Researching[k + 1]
--				end
--				return
--			end
--		end
--	end
end

-- /run AddSpellToWatch("NONE", "Interface\\Icons\\INV_Misc_QuestionMark")
function QuickWarnings_PurgeWatchList()
	if (#watch == 0) then
		return
	end

	local j = 1
	for j = 1, #watch do
		local found = nil
		local i = 1
		while true do
			local buffName = UnitBuff("player", i);
			if (buffName == nil) then
				break
			end

			--print(watch[j][2]..":"..buffName)
			if (watch[j]) then
				if (watch[j][2] == buffName) then
					found = buffName
					break
				end
			end
			i = i + 1
		end
		
		if (found) then
		elseif (watch[j]) then
			--print(watch[j][2])
			--print(j)
			-- quick warnings still has the icon floating on top, but the buff itself has already been removed
			RemoveSpellFromWatch(watch[j][2])
		end
	end
end


function QuickWarnings_OnEvent(self, event, ...)
	if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		local type, who, to = select(2,...), select(4,...), select(8,...)
		--ChatFrame1:AddMessage(to);
		--ChatFrame1:AddMessage(UnitGUID("player"));
		if (to == UnitGUID("player")) then
			--ChatFrame1:AddMessage(type);
			if (type == "UNIT_DIED") then
				QuickWarnings_PurgeWatchList()
			end
			if (who == UnitGUID("player")) then
				--ChatFrame1:AddMessage(type);
				if (type == "SPELL_AURA_REFRESH") then
					local SpellID = select(12,...)
					--ChatFrame1:AddMessage(SpellID)
					local name, rank, icon = GetSpellInfo(SpellID);
					--ChatFrame1:AddMessage("Spell: |Hspell:" .. SpellID .."|h|r|cff71d5ff[" .. name .. " " .. rank .. "]|r|h");
					--ChatFrame1:AddMessage(icon)
					
					RefreshSpellToWatch(name, icon)
				elseif (type == "SPELL_AURA_APPLIED") then
					local SpellID = select(12,...)
					--ChatFrame1:AddMessage(SpellID)
					local name, rank, icon = GetSpellInfo(SpellID);
					--ChatFrame1:AddMessage("Spell: |Hspell:" .. SpellID .."|h|r|cff71d5ff[" .. name .. " " .. rank .. "]|r|h");
					--ChatFrame1:AddMessage(icon)
					
					AddSpellToWatch(name, icon)
				elseif (type == "SPELL_AURA_REMOVED") then
					local SpellID = select(12,...)
					local name, rank, icon = GetSpellInfo(SpellID);
					--ChatFrame1:AddMessage("Spell: |Hspell:" .. SpellID .."|h|r|cff71d5ff[" .. name .. " " .. rank .. "]|r|h");
					--ChatFrame1:AddMessage(icon)
					
					RemoveSpellFromWatch(name)
				end
			end
		end
	elseif (event == "PLAYER_ENTERING_WORLD") then
	--	print("PLAYER_ENTERING_WORLD")
		QuickWarnings_PurgeWatchList()
	elseif (event == "PLAYER_DEAD") then
	--	QuickWarnings_PurgeWatchList()
	end
end